﻿package com.hydrotik.bannerflip3d {
	/**
	 * @author Donovan Adams
	 * @version December 10, 2007
	 * @description Papervision Page flip example
	 * 
	 */
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;

	import com.hydrotik.bannerflip3d.Flip;
	import com.hydrotik.bannerflip3d.FlipEvent;
	import com.hydrotik.utils.XMLLoader;
	import com.hydrotik.utils.XMLLoaderEvent;
	
	import flash.system.Capabilities;	

	public class Core extends Sprite {

		private var _scope:MovieClip;

		private var _stage:Stage;

		private var _xml:XML;

		private var _url:String;

		private var _hit: Sprite;
		
		private var _targ : String;

		public function Core(scope:MovieClip, stage:Stage):void {
			_scope = scope;
			_stage = stage;
			var p:String;
			if (Capabilities.playerType == "External" || Capabilities.playerType == "StandAlone") {
				p = "../includes/admin/flippingbanner.xml";
			} else {
			    p = "/wp-content/flippingbanner2/includes/admin/flippingbanner.xml";
			}
			var xml:XMLLoader = new XMLLoader(p);
			xml.addEventListener(XMLLoaderEvent.COMPLETE, onXMLComplete);
			xml.addEventListener(XMLLoaderEvent.ERROR, onXMLError);
		}
		
		private function onXMLError(event : XMLLoaderEvent) : void {
			trace(event);
		}

		// --== Private Methods ==--
		private function onXMLComplete(event:XMLLoaderEvent):void {
			trace(":: onXMLComplete:");
			_xml = event.xml;

			var _oFlip:Flip = new Flip(_scope, _stage, this, event.xml.banner.children(), "", new int(_xml.attribute("seconds")));
			_oFlip.addEventListener(FlipEvent.COMPLETE, onCompleteHandler);
			_oFlip.addEventListener(FlipEvent.ON_FLIP, onFlipHandler);

			_hit = new Sprite();
			_hit.graphics.beginFill(0x660000, 0);
			_hit.graphics.drawRect(0, 0, _stage.stageWidth, _stage.stageHeight);
			_scope.addChild(_hit);
			_hit.addEventListener(MouseEvent.CLICK, onClickHandler);

			_hit.buttonMode = true;
			_hit.useHandCursor = true;
			_hit.mouseEnabled = true;
		}

		private function onClickHandler(event:MouseEvent):void {
			navigateToURL(new URLRequest(_url), _targ);
		}

		private function onCompleteHandler(event:FlipEvent):void {
			_url = event.link;
			_targ = event.targ;
		}

		private function onFlipHandler(event:FlipEvent):void {
			_url = event.link;
			_targ = event.targ;
		}

	}
}