﻿/*
 * Copyright 2006-2007 (c) Donovan Adams, http://blog.hydrotik.com/
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */

package com.hydrotik.utils {
	
	import flash.events.Event;

	/**
	* Custom Event Class for XMLLoader
	*/
	public class XMLLoaderEvent extends Event {
		
		public static var COMPLETE 					:String = "complete";
		
		public static var PROGRESS 					:String = "progress";
		
		public static var ERROR	 					:String = "error";
		
		public var xml:XML;
		
		public var percentage:Number;

		public function XMLLoaderEvent( type:String, xml:XML = null, percentage:Number = 0, bubbles:Boolean=false, cancelable:Boolean=false) {
			super( type, bubbles, cancelable );
			this.xml = xml;
			this.percentage = percentage;
		}
	}
}