package com.zupko.papervision3d.utils
{
	import org.papervision3d.cameras.Camera3D;
	import org.papervision3d.lights.PointLight3D;
	import org.papervision3d.objects.DisplayObject3D;
	
	public class ShaderCameraControl
	{
		public var model:DisplayObject3D;
		public var light:PointLight3D;
		public var camera:Camera3D = new Camera3D();
				
		public function ShaderCameraControl(){

			camera.focus = 120;
			camera.zoom = 11;
		}
		
		public function register(model:DisplayObject3D, light:PointLight3D):void{
			registerModel(model);
			registerLight(light);
		}
		public function registerModel(model:DisplayObject3D):void{
			camera.target = model;
			this.model = model;
		}
		
		public function registerLight(light:PointLight3D):void{
			this.light = light;
		
		}
		
		public function update(xPos:Number, yPos:Number, trackLight:Boolean = true):void{
			camera.hover(0, xPos, yPos);
			if(trackLight)
				light.copyPosition(camera);
		}
	}
}