﻿package org.fuseproject.go.events {
	import flash.events.Event;
	
	/**
	 * Standard event set for all playable Go classes.
	 * 
	 * @author Moses Gunesch / mosessupposes.com (c) all rights reserved
	 */
	public class GoEvent extends Event
	{
		// TODO: add flex event metatags to dispatching classes
		
	    /**
	     * Indicates a playable instance is starting.
	     * 
	     * @eventType playableStart     
	     */
	    public static const START : String = 'playableStart';
		
		
	    /**
	     * Indicates a playable instance is updating.
	     * 
	     * @eventType playableUpdate
	     */
	    public static const UPDATE : String = 'playableUpdate';
		
		
	    /**
	     * Indicates a playable instance was manually stopped.
	     * 
	     * @eventType playableStop
	     */
	    public static const STOP : String = 'playableStop';
		
		
	    /**
	     * Indicates a playable instance that can end on its own has successfully finished.
	     * 
	     * @eventType playableComplete
	     * @see STOP
	     */
	    public static const COMPLETE : String = 'playableComplete';

		
		/**
		 * @param type The event type; indicates the action that triggered the event.
		 * @param bubbles Specifies whether the event can bubble up the display list hierarchy.
		 * @param cancelable Specifies whether the behavior associated with the event can be prevented.
		 */
		public function GoEvent(type:String, bubbles:Boolean=false, cancelable:Boolean=false)
		{
			super(type, bubbles, cancelable);
		}
	}
}
