package org.fuseproject.go.interfaces {
	import flash.events.IEventDispatcher;

	/**
	 * Defines a standard set of play controls.
	 * 
	 * @see org.fuseproject.go.PlayableBase#
	 * @author Moses Gunesch / mosessupposes.com (c) all rights reserved
	 */
	public interface IPlayable extends IEventDispatcher 
	{
		/**
		 * Start playing.
		 */
		function start () : Boolean;

		/**
		 * Stop playing.
		 */
		function stop () : Boolean;
		
		/**
		 * Pause play.
		 */
		function pause () : Boolean;
		
		/**
		 * Resume paused play.
		 */
		function resume () : Boolean;
		
		/**
		 * @param position	Index indicating point in animation to skipTo.
		 * 					(Remember that you can rename paramters when
		 * 					implementing an interface in AS3, for example
		 * 					"seconds" or "index" instead of "position.")
		 */
		function skipTo (position : Number) : Boolean;
		
	}
}
